package org.manzerbredes.client;

import java.awt.EventQueue;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.manzerbredes.open_klm.device.Driver.Color;
import org.manzerbredes.open_klm.device.Driver.Intensity;
import org.manzerbredes.open_klm.device.Driver.Region;
import org.manzerbredes.open_klm.device.Keyboard;

public class MainWindow extends JFrame {
	
	
	private JComboBox<Color> left;
	private JComboBox<Color> middle;
	private JComboBox<Color> right;
	private JButton apply=new JButton("Apply");
	
	private Keyboard keyboard;
	
	public MainWindow() throws InstantiationException{
		this.initUI();
		this.keyboard=new Keyboard();
		this.left=new JComboBox<>(Color.values());
		this.middle=new JComboBox<>(Color.values());
		this.right=new JComboBox<>(Color.values());
		
		
		this.apply.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				Color leftRegion=(Color) left.getSelectedItem();
				Color middleRegion=(Color) middle.getSelectedItem();
				Color rightRegion=(Color) right.getSelectedItem();

				keyboard.setRegionColor(Region.LEFT, leftRegion, Intensity.HIGH);
				keyboard.setRegionColor(Region.MIDDLE, middleRegion, Intensity.HIGH);
				keyboard.setRegionColor(Region.RIGHT, rightRegion, Intensity.HIGH);

				
			}
		});
		
		
		JPanel container = new JPanel();
		BoxLayout gridLayout=new BoxLayout(container, BoxLayout.Y_AXIS);
		
		container.add(new Label("Test interface"));
	
		container.add(left);
		container.add(middle);
		container.add(right);
		
		container.add(this.apply);

		this.add(container);
		

		
		this.setVisible(true);
	}
	
	private void initUI(){
		this.setTitle("Open KLM");
		this.setSize(700, 500);
        setLocationRelativeTo(null);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
	}
	
}