package org.manzerbredes.open_klm.device;

import java.util.HashMap;

import org.javatuples.Pair;
import org.manzerbredes.open_klm.device.Driver.Color;
import org.manzerbredes.open_klm.device.Driver.Intensity;
import org.manzerbredes.open_klm.device.Driver.Mode;
import org.manzerbredes.open_klm.device.Driver.Region;

public class KeyboardState {
	
	/**
	 * Define Keyboard color state
	 */
	private HashMap<Region, Pair<Color,Intensity>> KeyboardColor=new HashMap<>();
	
	/**
	 * Define Keyboard mode state
	 */
	private Mode mode;
	
	
	public KeyboardState() {
		this.mode=Mode.NORMAL;
	}
	
	public void setColor(Color color, Intensity intensity){
		this.KeyboardColor.put(Region.LEFT, new Pair<Driver.Color, Driver.Intensity>(color, intensity));
		this.KeyboardColor.put(Region.MIDDLE, new Pair<Driver.Color, Driver.Intensity>(color, intensity));
		this.KeyboardColor.put(Region.RIGHT, new Pair<Driver.Color, Driver.Intensity>(color, intensity));
	}

	public void setRegionColor(Region region, Color color, Intensity intensity){
		this.KeyboardColor.put(region, new Pair<Driver.Color, Driver.Intensity>(color, intensity));
	}
	
	
	/**
	 * @return the mode
	 */
	public Mode getMode() {
		return mode;
	}

	/**
	 * @param mode the mode to set
	 */
	public void setMode(Mode mode) {
		this.mode = mode;
	}
	
	

}
